<?php
/*
    LWAT, LDAP Webbased Administration Tool
    Copyright (C) 2007  Finn-Arne Johansen <faj@bzz.no>, BzzWare AS, Norway

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

require_once ("functions.php"); 
loadConfig () ; 
session_start () ; 

require_once ("createlm.php"); 
require('/usr/share/php/smarty/libs/Smarty.class.php') ; 

loadLocale () ;
ob_start () ; 

$smarty = new Smarty();
$smarty->template_dir = $smarty_templ ; 
$smarty->compile_dir = $smarty_compile ; 

function showHost ($ldap, $authenticated, $cn) {
    global $smarty, $hostbase, $base ; 
    $filter="cn=" . $cn ;
    $want = array ("cn", "ipHostNumber", "associatedDomain") ;
    $searchbase=$hostbase ; 
    $result = ldap_search($ldap, $searchbase, $filter, $want);
    $entries = ldap_get_entries ($ldap, $result);
    $count=$entries["count"] ;
    if ($count) {
        $cn=$entries[0]["cn"][0]; 
        $ipAddress=$entries[0]["iphostnumber"][0];
        $domain=$entries[0]["associateddomain"][0];
        $smarty->assign ('cn', $cn) ; 
	$smarty->assign ('ipAddress', $ipAddress) ;
	$smarty->assign ('domain', $domain) ; 
	$smarty->assign ('memberOf', $memberOf) ; 
	$smarty->assign ('notMemberOf', $notMemberOf) ; 
	showHostGroups ($ldap, $authenticated, $cn) ; 
	$smarty->display('admin_host_show.tpl') ;
    } else {
        printf (_("No matching objects") ."<BR>") ;
    }
}

function showHostGroups ($ldap, $authenticated, $cn) {
    global $smarty, $netgroupbase ;

    $filter="(&(objectClass=nisNetGroup)(!(memberNisNetGroup=*)))" ; 
	$want = array ("cn", "nisNetGroupTriple") ;
    $searchbase=$netgroupbase ; 
        $result = ldap_search($ldap, $searchbase, $filter, $want);
        if ($result) {
	    $entries = ldap_get_entries ($ldap, $result);
	    for ($i = 0 ; $i < $entries["count"] ; $i++) {
	    if (@in_array ('(' . $cn . ',-,-)', $entries[$i]["nisnetgrouptriple"]))
	           $memberOf[] = $entries[$i]['cn'][0] ; 
	       else
	           $notMemberOf[] = $entries[$i]['cn'][0] ; 
            }
        } 
    if ($authenticated) {
        $groupTarget='\'sub\'' ;
        $delAction ='\'hostDelGroup&cn=' . $cn ; 
        $delAction .= '&group=\' + member.value' ;
        $addAction ='\'hostAddGroup&cn=' . $cn ; 
        $addAction .= '&group=\' + nonmember.value';
    } else {
        $groupTarget = '\'logout\'' ; 
        $delAction = '\'loginForm\'' ; 
        $addAction = '\'loginForm\'' ; 
    }
    $smarty->assign('memberOf', $memberOf) ; 
    $smarty->assign('notMemberOf', $notMemberOf) ; 
    $smarty->assign('groupTarget', $groupTarget) ; 
    $smarty->assign('addAction', $addAction) ; 
    $smarty->assign('delAction', $delAction) ; 
}

function userDelGroup ($ldap, $uid, $gid) {
    global $groupbase, $base ; 
    $filter="(&(objectClass=posixGroup)(gidNumber=" . $gid . "))";
    $want = array ('cn'); 
    $searchbase=$groupbase ; 
    $result = ldap_search($ldap, $searchbase, $filter, $want);
    $entries = ldap_get_entries ($ldap, $result);
    $groupdn=$entries[0]["dn"] ; 
    $cn=$entries[0]["cn"][0] ; 
    $change = array (); 
    $change["memberUid"][] = $uid ; 
    @ldap_mod_del($ldap, $groupdn, $change) ;
    $want = array ('member'); 
    $filter="(&(member=*)(cn=" . $cn . "))";
    $result = ldap_search($ldap, $base, $filter, $want);
    $entries = ldap_get_entries ($ldap, $result);
    $groupdn=$entries[0]["dn"] ; 
    $change = array (); 
    if ($entries[0]["member"][count]) {
        $want = array (); 
	$filter="(&(objectClass=posixAccount)(uid=" . $uid  ."))";
	$result = ldap_search($ldap, $base, $filter, $want);
	$entries = ldap_get_entries ($ldap, $result) ; 
	$change["member"][] = $entries[0]["dn"] ; 
	ldap_mod_del($ldap, $groupdn, $change) ;
    }
}

function userAddGroup ($ldap, $uid, $gid) {
    global $groupbase, $base ; 
    $filter="(&(objectClass=posixGroup)(gidNumber=" . $gid . "))";
    $want = array ('cn'); 
    $searchbase=$groupbase ; 
    $result = ldap_search($ldap, $searchbase, $filter, $want);
    $entries = ldap_get_entries ($ldap, $result);
    $groupdn=$entries[0]["dn"] ; 
    $cn=$entries[0]["cn"][0] ; 
    $change = array (); 
    $change["memberUid"][] = $uid ; 
    @ldap_mod_add($ldap, $groupdn, $change) ;
    $filter="(&(member=*)(cn=" . $cn . "))";
    $result = ldap_search($ldap, $base, $filter, $want);
    $entries = ldap_get_entries ($ldap, $result);
    $groupdn=$entries[0]["dn"] ; 
    $change = array (); 
    if ($entries[count]) {
        $want = array (); 
	$filter="(&(objectClass=posixAccount)(uid=" . $uid  ."))";
	$result = ldap_search($ldap, $base, $filter, $want);
	$entries = ldap_get_entries ($ldap, $result) ; 
	$change["member"][] = $entries[0]["dn"] ; 
	@ldap_mod_add($ldap, $groupdn, $change) ;
    }
}

function hostAddGroup ($ldap, $cn, $group) {
    global $netgroupbase ; 
    $filter="(&(objectClass=nisNetGroup)(cn=" . $group . "))";
    $want = array ('nisNetgroupTriple'); 
    $searchbase=$netgroupbase ; 
    $result = ldap_search($ldap, $searchbase, $filter, $want);
    $entries = ldap_get_entries ($ldap, $result);
    if (@in_array ('(' . $cn . ',-,-)', $entries[$i]["nisnetgrouptriple"]) === false ) {
	$groupdn=$entries[0]["dn"] ; 
	$change = array () ; 
	for ($i = 0 ; $i < $entries[0]["nisnetgrouptriple"][count] ; $i++) {
	    $change["nisNetgroupTriple"][] = $entries[0]["nisnetgrouptriple"][$i] ;
	}
	$change["nisNetGroupTriple"][] = "(" . $cn . ",-,-)" ; 
	ldap_modify($ldap, $groupdn, $change) ;
    }
}

function hostDelGroup ($ldap, $cn, $group) {
    global $netgroupbase ; 
    $filter="(&(objectClass=nisNetGroup)(cn=" . $group . "))";
    $want = array ('nisNetgroupTriple'); 
    $searchbase=$netgroupbase ; 
    $result = ldap_search($ldap, $searchbase, $filter, $want);
    $entries = ldap_get_entries ($ldap, $result);
    $groupdn=$entries[0]["dn"] ; 
    $change = array () ; 
    $change["nisNetgroupTriple"] = array () ; 
    for ($i = 0 ; $i < $entries[0]["nisnetgrouptriple"][count] ; $i++) {
	if ($entries[$i]["nisnetgrouptriple"][$i] <>  '(' . $cn . ',-,-)')
	    $change["nisNetgroupTriple"][] = $entries[0]["nisnetgrouptriple"][$i] ;
    }
    ldap_modify($ldap, $groupdn, $change) ; 
}

function changeGroup ($ldap, $gid, $cn, $description, $auth) {
    global $base, $useLisGroup, $groupbase, $authbase ; 
    $filter="(&(objectClass=posixGroup)(gidNumber=" . $gid . "))";
    $want = array ('objectClass', 'description', 'memberUid', 'cn'); 
    $searchbase=$groupbase ; 
    $result = ldap_search($ldap, $searchbase, $filter, $want);
    $entries = ldap_get_entries ($ldap, $result);
    $groupdn = $entries[0]["dn"] ; 
    $cn=$entries[0]["cn"][0] ;
    $change = array (); 
    if ($description <> $entries[0]["description"][0]) {
	$change["description"][] = $description ; 
    }
    if (count ($change)) ldap_modify($ldap, $groupdn, $change) ;
    $change = array (); 
    if (!$useLisGroup) {
	$filter="(&(member=*)(cn=" . $cn . "))";
	$want = array ('objectClass', 'member'); 
	$result = ldap_search($ldap, $base, $filter, $want);
	$count = ldap_count_entries ($ldap, $result) ;
        if ($auth) {
            if ($count == 0) {
                $change["objectClass"] = array('top', 'groupOfNames') ; 
                $change["cn"] = $cn ; 
                $want = array ('dn') ; 
                for ($i = 0 ; $i < $entries[0]["memberuid"][count] ; $i++) {
                    $filter = '(&(objectClass=posixAccount)(uid=' . 
                               $entries[0]["memberuid"][$i] . '))' ; 
		    $result = ldap_search($ldap, $base, $filter, $want);
		    if (ldap_count_entries ($ldap, $result) == 1) {
		        $member = ldap_get_entries ($ldap, $result) ; 
		        $change["member"][] = $member[0]["dn"] ; 
		    }
		}
                if  (count($change["member"]) > 0)
                    if (!ldap_add ($ldap, "cn=" . $cn . "," . $authbase, $change))
                        debug (array ('dn' => "cn=" . $cn . "," . $authbase, 
                                      'change' => $change)); 
            }
        } else {
            if ($count > 0) {
		$entries = ldap_get_entries ($ldap, $result) ; 
		ldap_delete ($ldap, $entries[0]["dn"]) ;
            }
        }
    }
    showGroup ($ldap, $gid);
}

function addHost ($ldap, $cn, $ipaddress, $domain) {
    global $hostbase ; 
    $filter="cn=" . $cn ;
    $want = array ("cn"); 
    $searchbase=$hostbase ; 
    $result = ldap_search($ldap, $searchbase, $filter, $want);
    $entries = ldap_get_entries ($ldap, $result);
    if ($entries["count"] > 0)  {
        printf (_("Sorry, there is already a host with the name %s") . "<BR>", $cn ); 
    } else {  
	$add = array (); 
	$add["objectClass"] = array ("top", "organizationalRole", "ipHost", "domainRelatedObject") ; 
	$add["cn"] = $cn ; 
	$add["ipHostNumber"] = $ipaddress ;
	$add["associatedDomain"] = $domain ; 
	if (! ldap_add($ldap, "cn=" . $cn . "," . $hostbase, $add))
	    debug (array('dn' => "cn=" . $cn . "," . $hostbase,
	                 'add' => $add)) ;
    }
    showHost ($ldap, true, $cn);
}

function addGroup ($ldap, $cn, $description) {
    global $useLisGroup, $groupbase, $base ; 
    $filter="(|(uid=" . $cn . ")(cn=" . $cn . "))";
    $want = array ("cn","uid"); 
    $searchbase=$base ; 
    $result = ldap_search($ldap, $searchbase, $filter, $want);
    $entries = ldap_get_entries ($ldap, $result);
    if ($entries["count"] > 0)  {
        printf (_("Sorry, there is already a group/user with the name %s") . "<BR>", $cn ); 
        $gidNumber = $entries[0]["gidNumber"][0] ;
    } else {  
	$gidNumber = getnextid ($ldap, $base) ;
	$add = array (); 
	if ($useLisGroup) {
	    $add["objectClass"] = array ("top", "posixGroup", "lisGroup") ; 
	    $add["groupType"] = "school_class" ; 
	} else
	    $add["objectClass"] = array ("top", "posixGroup") ; 
	$add["cn"] = $cn ; 
	$add["gidNumber"] = $gidNumber ;
	$add["description"] = $description ; 
	ldap_add($ldap, "cn=" . $cn . "," . $groupbase, $add) ;
    }
    showGroup ($ldap, $gidNumber);
}

function sambaAddInfo ($ldap, $userldif, $userpw) {
    $sambahash = new smbHash () ;
    $sambaldif = array ()  ;
    $sambaldif['sambaSID'] = get_sambasid ($ldap, $userldif['uidNumber']) ;
    $sambaldif["sambaAcctFlags"] = "[U          ]" ;
    $sambaldif["sambaLMPassword"] = $sambahash->lmhash($userpw) ; 
    $sambaldif["sambaNTPassword"] = $sambahash->nthash($userpw) ; 
    return $sambaldif ;
}

function addUser ($ldap, $cn, $template, $username) {
    global $groupbase, $base, $domain, $useLisGroup ; 
    $templates = parse_ini_file ('/etc/lwat/admin.ini', true) ; 
    $template = $templates[$template] ;
    $userpw = pwgen () ;
    $sn = get_sn ($username) ;
    $userid = getnextid ($ldap, $base) ;
    $userldif['uidNumber'] = $userid ;
    $userldif['gidNumber'] = $userid ;
    $userldif['uid'] = $username ;
    $userldif['cn'] = $cn ;
    $userldif['userPassword'] = cryptgen($userpw) ;
    if ($useLisGroup) {
	$groupldif["objectClass"] = array ("top", "posixGroup", 'lisGroup') ; 
	$groupldif["groupType"] = "private" ;
    } else
	$groupldif["objectClass"] = array ("top", "posixGroup") ; 
    $groupldif["cn"] = $username ; 
    $groupldif["gidNumber"] = $userid ;
    $groupldif["description"] = "$cn personal group" ;
    $replace=array("%username%", "%base%", "%domain%", "%sn%") ;
    $replacewith =array($username, $base, $domain, $sn) ;
    foreach ($template as $key => $value) {
        $value = str_replace ($replace, $replacewith, $value) ;
        switch ($key) {
             case "ou":
                 $ou=$value ;
                 break ;
             case "groups":
                 $groups= explode (" ", $value) ;
                 break ;
             case "objectClass":
                 $userldif['objectClass'] = explode (" ", $value); 
                 break ;
             default:
                 $userldif[$key] = $value ;
                 break ;
        }
    }
    if (in_array ('sambaSamAccount',$userldif['objectClass'])) 
        $userldif = (array_merge($userldif, sambaAddInfo ($ldap, $userldif, $userpw))) ;
    if (!ldap_add($ldap, "uid=" . $username . "," . $ou, $userldif)) {
        debug (array_merge(array ('dn' => "uid=" . $username . "," . $ou), $userldif)) ;
        return ; 
    }
    if ($useLisGroup) $ou=$groupbase ;
    if (!ldap_add($ldap, "cn=" . $username . "," . $ou, $groupldif)) {
        debug (array('dn' => "cn=" . $username . "," . $ou, 'groupldif' => $groupldif)) ;
        return ;
    }
    foreach ($groups as $group) {
        $filter="(&(objectClass=posixGroup)(cn=" . $group . "))";
        $want = array ('gidNumber'); 
        $result = ldap_search($ldap, $groupbase, $filter, $want);
        $entries = ldap_get_entries ($ldap, $result);
        $gid= $entries[0]['gidnumber'][0] ;
        userAddGroup ($ldap, $username, $gid) ;
    }
    printf(_("Added user %s with username %s and password %s"), $cn, $username, $userpw);
    userAddForm (true) ;
}

function changeUser ($ldap, $uid, $cn) {
    global $base ; 
    $filter="(&(objectClass=posixAccount)(uid=" . $uid . "))";
    $want = array (); 
    $result = ldap_search($ldap, $base, $filter, $want);
    $entries = ldap_get_entries ($ldap, $result);
    $change = array (); 
    $change["cn"][] = $cn ; 
    if (!ldap_modify($ldap, $entries[0]["dn"], $change))
        debug (array ('dn' => $entries[0]["dn"], 'change' => $change)) ;
    showUser ($ldap, true, $uid); 
}

function showGroup ($ldap, $gid) {
    global $useLisGroup, $smarty, $base, $authbase, $groupbase ; 
    $filter="(&(objectClass=posixGroup)(gidNumber=" . $gid . "))";
    $want = array ("memberUid", "member", "description", "cn", "objectClass") ;
    $searchbase=$groupbase ; 
    $result = ldap_search($ldap, $searchbase, $filter, $want);
    $entries = ldap_get_entries ($ldap, $result);
    $authentication= ( $entries[0]["member"]["count"] > 0 ); 
    $smarty->assign('description', $entries[0]["description"][0]); 
    $smarty->assign('cn', $entries[0]["cn"][0]); 
    $smarty->assign('gid', $gid) ; 
    if ($useLisGroup) {
        if (in_array ('lisAclGroup', $entries[0]["objectclass"]))
            $smarty->assign ('authentication', 'checked disabled'); 
        else 
            $smarty->assign ('authentication', 'disabled'); 
    } else {
        $result = ldap_search ($ldap, $authbase, 
                               'cn=' . $entries[0]["cn"][0]); 
        if (ldap_count_entries ($ldap, $result))
            $smarty->assign ('authentication', 'checked'); 
    }
    $memberUid=$entries[0]["memberuid"];
    $filter="" ; 
    for ($i=0 ; $i < $memberUid["count"] ; $i++) {
        $filter .= "(uid=" . $memberUid[$i] . ")" ; 
    }
    $filter="(&(objectClass=posixAccount)(|" . $filter . "))" ; 
    $want = array ("uid", "cn") ;
    $searchbase=$base ; 
    $result = ldap_search($ldap, $searchbase, $filter, $want);
    $entries = ldap_get_entries ($ldap, $result);
    $username = array () ; 
    $display = array () ; 
    for ($i=0 ; $i < $entries["count"] ; $i++) {
        $username[] = $entries[$i]["uid"][0] ;
        $display[] = $entries[$i]["cn"][0] ; 
    }
    $smarty->assign('username', $username) ; 
    $smarty->assign('display', $display) ; 
    $smarty->display('admin_group_show.tpl') ;

}

function showUser ($ldap, $authenticated, $uid) {
    global $smarty, $base, $groupbase ; 
    $filter="(&(objectClass=posixAccount)(uid=" . $uid . "))";
    $want = array ("uidNumber", "uid", "cn", "gidNumber") ;
    $searchbase=$base ; 
    $result = ldap_search($ldap, $searchbase, $filter, $want);
    $entries = ldap_get_entries ($ldap, $result);
    $count=$entries["count"] ;
    if ($count) {
        $cn=$entries[0]["cn"][0]; 
        $uidNumber=$entries[0]["uidnumber"][0];
        $gidNumber=$entries[0]["gidnumber"][0];
	$filter="(&(objectClass=posixGroup)(gidNumber=" . $gidNumber . ")(!(cn=nextID))(!(cn=lastID)))";
	$want = array ("cn", "gidNumber") ;
	$searchbase=$base ; 
        $result = ldap_search($ldap, $searchbase, $filter, $want);
	$entries = ldap_get_entries ($ldap, $result);
        $userGroup=$entries[0]["cn"][0]; 
	$smarty->assign('uid', $uid) ;  
	$smarty->assign('uidNumber', $uidNumber) ;  
	$smarty->assign('cn', $cn) ;  
	$smarty->assign('userGroup', $userGroup) ;  
	showUserGroups($ldap, $authenticated, $uid) ; 
	$smarty->display ('admin_user_show.tpl') ;  
    } else {
        printf (_("No matching objects") ."<BR>") ;
    }
}

function showUserGroups ($ldap, $authenticated ,$uid) {
    global $smarty, $useLisGroup, $groupbase ;

    if ($useLisGroup) 
	$filter="(&(objectClass=posixGroup)(!(groupType=private))(memberUid=" . $uid . "))";
    else
	$filter="(&(objectClass=posixGroup)(memberUid=" . $uid . "))";
    $want = array ("cn", "gidNumber") ;
    $searchbase=$groupbase ; 
    $result = ldap_search($ldap, $searchbase, $filter, $want);
    $entries = ldap_get_entries ($ldap, $result);
    for ($i=0 ; $i < $entries["count"] ; $i++) {
        $memberValues[] = $entries[$i]["gidnumber"][0] ;
        $memberDisplays[] = $entries[$i]["cn"][0] ;
    }
    if ($useLisGroup) 
	$filter="(&(objectClass=posixGroup)(!(groupType=private))(!(memberUid=" . $uid . ")))";
    else
	$filter="(&(objectClass=posixGroup)(!(memberUid=" . $uid . ")))";
    $want = array ("cn", "gidNumber") ;
    $searchbase=$groupbase ; 
    $result = ldap_search($ldap, $searchbase, $filter, $want);
    $entries = ldap_get_entries ($ldap, $result);
    for ($i=0 ; $i < $entries["count"] ; $i++) {
        $nonMemberValues[] = $entries[$i]["gidnumber"][0] ;
        $nonMemberDisplays[] = $entries[$i]["cn"][0] ;
    }
    if ($authenticated) {
        $groupTarget='\'sub\'' ;
        $delAction ='\'userDelGroup&uid=' . $uid ; 
        $delAction .= '&gid=\' + member.value' ;
        $addAction ='\'userAddGroup&uid=' . $uid ; 
        $addAction .= '&gid=\' + nonmember.value';
    } else {
        $groupTarget = '\'logout\'' ; 
        $delAction = '\'loginForm\'' ; 
        $addAction = '\'loginForm\'' ; 
    }
    $smarty->assign('memberValues', $memberValues) ; 
    $smarty->assign('memberDisplays', $memberDisplays) ; 
    $smarty->assign('nonMemberValues', $nonMemberValues) ; 
    $smarty->assign('nonMemberDisplays', $nonMemberDisplays) ; 
    $smarty->assign('groupTarget', $groupTarget) ; 
    $smarty->assign('addAction', $addAction) ; 
    $smarty->assign('delAction', $delAction) ; 
}


function showResult ($ldap, $type, $text, $searchDisabled) {
    global $smarty, $useLisGroup, $base, $groupbase, $hostbase ; 

    if ($text == "*") $text="" ; 
    switch ($type) {
        case "User":
            if ($searchDisabled == 'true')
		$filter="(&(objectClass=posixAccount)(shadowFlag=1)" . 
		        "(|(cn=" . $text . "*)(uid=" . $text . "*)))";
            else
		$filter="(&(objectClass=posixAccount)" .
		        "(|(cn=" . $text . "*)(uid=" . $text . "*)))";
	    $want = array ("uidNumber", "uid", "cn") ;
	    $searchbase=$base ; 
	    $action="showUser" ; 
	    $show="uid" ; 
            break ;
        case "Group":
            if ($useLisGroup)
                $filter="(&(objectClass=posixGroup)(!(groupType=private))(cn=" . $text . "*))" ;
            else 
                $filter="(&(objectClass=posixGroup)(cn=" . $text . "*))" ;
	    $want = array ("gidNumber", "cn") ;
	    $searchbase=$groupbase ; 
	    $action="showGroup" ; 
	    $show="gidnumber" ; 
            break ;
        case "Hosts":
            $filter="cn=" . $text . "*" ;
	    $want = array ("cn") ;
	    $searchbase=$hostbase ; 
	    $action="showHost" ; 
	    $show="cn" ; 
            break ;
        default:
           return ;
    }
    $result = ldap_search($ldap, $searchbase, $filter, $want);
    if (! $result)
        debug (array ('searchbase' => $searchbase,
                      'filter' => $filter,
                      'want' => $want)) ; 
    $entries = ldap_get_entries ($ldap, $result);
    $count=$entries["count"] ;
    if ($count > 50)
        printf (_("Too many entries, please narrow your search") . "<BR>\n") ; 
    elseif ($count) {
	for ($i=0 ; $i < $count ; $i++) {
	    $value[]=$entries[$i][$show][0] ; 
	    $display[] = $entries[$i]['cn'][0] ; 
	    $dn[] = $entries[$i]['dn'] ; 
	}
	$smarty->assign('searchDisabled', $searchDisabled) ; 
	$smarty->assign('action', $action) ; 
	$smarty->assign('value', $value) ; 
	$smarty->assign('dn', $dn) ; 
	$smarty->assign('display', $display) ; 
	$smarty->display('admin_result.tpl') ;
    } else {
        printf (_("No matching objects") . "<BR>") ;
    }
}

function userAddForm ($authenticated) {
    global $smarty ; 
    
    $templates = parse_ini_file ("/etc/lwat/admin.ini", true); 
    foreach ($templates as $name => $fields) 
        $templname[] = $name ; 
    $smarty->assign ('templates',$templname) ;
    if ($authenticated) {
        $target = '\'main\'' ; 
	$action = '\'addUser&cn=\' + cn.value '; 
	$action .= ' + \'&username=\' + username.value' ;
	$action .= ' + \'&template=\' + template.value' ;
    } else {
	$action = '\'loginForm\'' ; 
        $target = '\'logout\'' ; 
    }
    $smarty->assign ('target', $target) ;  
    $smarty->assign ('action', $action) ;  
    $smarty->display ('admin_user_add.tpl') ; 
}

$ldap=ldap_connect ($ldaphost); 
$authenticated = ($_COOKIE['Authenticated'] == "True") ;
$key = $_SESSION['key'] ;
if ($key == "") {
    if ($authenticated) {
        setcookie ("Authenticated", "False", time () + 1800) ;
    }
    $authenticated = false ; 
} 
ldap_set_option($ldap, LDAP_OPT_PROTOCOL_VERSION, 3);
@ldap_start_tls($ldap) ; 
if ($authenticated) {
    $admindn = $_COOKIE['admindn'] ; 
    $xorstring = $_COOKIE['xorstring'] ; 
    if ($xorstring <> "") {
	$adminpw = xorstring ($key, $xorstring) ; 
	$authenticated = ($adminpw <> "") ;
    } else 
        $authenticated = false ; 
}
if ($authenticated) {
    $bind = @ldap_bind ($ldap, $admindn, $adminpw); 
    setcookie ("Authenticated", "True", time () + 1800) ;
    setcookie ("admindn", $admindn, time () + 1800) ;
    setcookie ("xorstring", $xorstring, time () + 1800) ;
} else {
    unset ($_SESSION['key']) ; 
    $bind = @ldap_bind ($ldap) ;
}

switch (readKey('action')) {
    case "userAddForm":
        userAddForm ($authenticated) ;
        break ;
    case "groupAddForm":
	if ($authenticated) {
	    $action ='\'addGroup&cn=\' + cn.value '; 
	    $action .= ' + \'&description=\' + description.value' ;
	    $target = '\'main\'' ; 
	} else {
	    $action = '\'loginForm\'' ; 
	    $target = '\'logout\'' ; 
	}
	$smarty->assign ('action', $action) ;  
	$smarty->assign ('target', $target) ;  
	$smarty->display ('admin_group_add.tpl') ; 
        break ;
    case "machineAddForm":
	if ($authenticated) {
	    $action ='\'addHost&cn=\' + cn.value '; 
	    $action .= ' + \'&ipaddress=\' + ipaddress.value' ;
	    $action .= ' + \'&domain=\' + domain.value' ;
	    $target = '\'main\'' ; 
	} else {
	    $action = '\'loginForm\'' ; 
	    $target = '\'logout\'' ; 
	}
	$smarty->assign ('action', $action) ;  
	$smarty->assign ('target', $target) ;  
	$smarty->display ('admin_host_add.tpl') ; 
        break ;
    case "groupSearch":
        $searchFor=readKey('Name') ;
        if ($searchFor <> "") showResult ($ldap, 'Group', $searchFor, ''); 
        break ;
    case "groupSearchForm":
        $smarty->display('admin_group_search.tpl') ;
        break ;
    case "userSearch":
        $searchFor=readKey('Name') ;
        if ($searchFor <> "") showResult ($ldap, 'User', $searchFor, readKey('searchDisabled')) ; 
        break ;
    case "userSearchForm":
        $result=ldap_search ($ldap, $base, 
                             "(&(objectClass=posixAccount)(shadowFlag=1))", 
                             array () ) ; 
        $smarty->assign ('searchDisabled', ldap_count_entries ($ldap, $result)) ; 
        $smarty->display('admin_user_search.tpl') ;
        break ;
    case "showUser":
        showUser ($ldap, $authenticated, readKey('text')); 
        break ;
    case "userDelGroup":
        $uid = readKey('uid') ;
        userDelGroup ($ldap, $uid, readKey('gid')); 
        showUserGroups ($ldap, $authenticated, $uid);
	$smarty->display('admin_user_show_group.tpl') ; 
        break ;
    case "hostDelGroup":
        $cn = readKey('cn') ;
        hostDelGroup ($ldap, $cn, readKey('group')); 
        showHostGroups ($ldap, $authenticated, $cn);
	$smarty->display('admin_host_show_group.tpl') ; 
        break ;
    case "hostAddGroup":
        $cn = readKey('cn') ;
        hostAddGroup ($ldap, $cn, readKey('group')); 
        showHostGroups ($ldap, $authenticated, $cn);
	$smarty->display('admin_host_show_group.tpl') ; 
        break ;
    case "userAddGroup":
        $uid = readKey('uid') ;
        userAddGroup ($ldap, $uid, readKey('gid')); 
        showUserGroups ($ldap, $authenticated, $uid);
	$smarty->display('admin_user_show_group.tpl') ; 
        break ;
    case "changeUser":
        changeUser ($ldap, readKey('uid'), readKey('cn')); 
        break ;
    case "changeGroup":
        changeGroup ($ldap, readKey('gid'), readKey('cn'), readKey('description'), (readKey('auth') == 'true')); 
        break ;
    case "showGroup":
        showGroup ($ldap,readKey('text')); 
        break ;
    case "addUser":
	$cn = readKey('cn') ;
	$template = readKey('template') ;
	$username = readKey ('username'); 
	addUser ($ldap, $cn, $template, $username); 
        break ; 
    case "groupDelete":
        $groupToDelete = array () ; 
        foreach ($_POST as $key => $value) 
            if (strpos($key, 'checked_') === 0 ) {
                $entry = ldap_explode_dn ($value, 1); 
		$groupToDelete[] = $entry[0] ; 
	    }
	if (empty ($groupToDelete)) {
	    printf (_("No groups to delete")) ;
	    break ;
	}
        $smarty->assign ('groupToDelete', $groupToDelete) ; 
        $smarty->display ('admin_group_delete.tpl') ; 
        break ; 
    case "groupDoDelete":
        $groupToDelete = array () ; 
        foreach ($_POST as $key => $value) 
            if (strpos($key, 'checked_') === 0 )
		$groupToDelete[] = $value ; 
	if (empty ($groupToDelete)) {
	    printf (_("No groups to delete")) ;
	    break ;
	}
        foreach ($groupToDelete as $cn ) {
            $want = array ('cn') ; 
            $filter = '(&(|(objectClass=posixGroup)(member=*))(cn=' . $cn . '))' ; ; 
	    $result = ldap_search ($ldap, $base, $filter, $want);
	    $entries = ldap_get_entries ($ldap, $result);
	    for ($i = 0 ; $i <  $entries[count] ; $i++) {
	        if (ldap_delete ($ldap, $entries[$i]["dn"]))
	            printf(_("Group %s deleted") . "<br>", $entries[$i]["dn"]) ; 
	    }
        }
        break ; 
    case "userEnable":
        $userToEnable = array () ; 
        $memberUid = '' ; 
        foreach ($_POST as $key => $value) 
            if (strpos($key, 'checked_') === 0 ) {
		$want = array ('memberUid') ; 
		$filter= '(&(objectClass=posixGroup))' ; 
                $result = ldap_search ($ldap, $value, $filter, $want) ; 
                $entries = ldap_get_entries ($ldap, $result) ; 
                if ($entries[count])
                    for ($group = 0 ; $group < $entries[count] ; $group++) {
                        $members = $entries[$group]['memberuid'] ; 
                        for ($member = 0 ; $member < $members[count] ; $member++) {
                            $memberUid .= '(uid=' . $members[$member] . ')' ; 
                        } 
                    }
                else {
		    $userToEnable[] = $value ; 
		}
	    }
	if (!empty ($memberUid)) {
	    $want = array () ; 
	    $filter = '(&(objectClass=posixAccount)(|' . $memberUid . '))' ; 
	    $result = ldap_search ($ldap, $base, $filter, $want) ; 
	    $entries = ldap_get_entries ($ldap, $result) ; 
	    for ($dn = 0 ; $dn < $entries[count] ; $dn++) 
		$userToEnable[] =$entries[$dn]['dn'] ; 
        }
	if (empty ($userToEnable)) {
	    printf (_("No users to enable")) ;
	    break ;
	}
        $smarty->assign ('userToEnable', $userToEnable) ; 
        $smarty->display ('admin_user_enable.tpl') ; 
        break ; 
    case "userDoEnable":
        $userToEnable = array () ; 
        foreach ($_POST as $key => $value) 
            if (strpos($key, 'checked_') === 0 ) {
		$userToEnable[] = $value ; 
	    }
	if (empty ($userToEnable)) {
	    printf (_("No users to enable")) ;
	    break ;
	}
        $want = array ('cn') ; 
        foreach ($userToEnable as $value ) {
            $enable['shadowFlag'] = '0' ; 
            $enable['loginShell'] = '/bin/bash' ; 
            $enable['sambaAcctFlags'] = '[U          ]' ; 
	    ldap_modify ($ldap, $value, $enable);
        }
        break ; 
    case "userDisable":
        $userToDisable = array () ; 
        $memberUid = '' ; 
        foreach ($_POST as $key => $value) 
            if (strpos($key, 'checked_') === 0 ) {
		$want = array ('memberUid') ; 
		$filter= '(&(objectClass=posixGroup))' ; 
                $result = ldap_search ($ldap, $value, $filter, $want) ; 
                $entries = ldap_get_entries ($ldap, $result) ; 
                if ($entries[count])
                    for ($group = 0 ; $group < $entries[count] ; $group++) {
                        $members = $entries[$group]['memberuid'] ; 
                        for ($member = 0 ; $member < $members[count] ; $member++) {
                            $memberUid .= '(uid=' . $members[$member] . ')' ; 
                        } 
                    }
                else {
		    $userToDisable[] = $value ; 
		}
	    }
	if (! empty ($memberUid)) {
	    $want = array () ; 
	    $filter = '(&(objectClass=posixAccount)(|' . $memberUid . '))' ; 
	    $result = ldap_search ($ldap, $base, $filter, $want) ; 
	    $entries = ldap_get_entries ($ldap, $result) ; 
	    for ($dn = 0 ; $dn < $entries[count] ; $dn++) 
		$userToDisable[] =$entries[$dn]['dn'] ; 
        }
	if (empty ($userToDisable)) {
	    printf (_("No users to disable")) ;
	    break ;
	}
        $smarty->assign ('userToDisable', $userToDisable) ; 
        $smarty->display ('admin_user_disable.tpl') ; 
        break ; 
    case "userDoDisable":
        $userToDisable = array () ; 
        foreach ($_POST as $key => $value) 
            if (strpos($key, 'checked_') === 0 ) {
		$userToDisable[] = $value ; 
	    }
	if (empty ($userToDisable)) {
	    printf (_("No users to disable")) ;
	    break ;
	}
        $want = array ('cn') ; 
        foreach ($userToDisable as $value ) {
            $disable['shadowFlag'] = '1' ; 
            $disable['loginShell'] = 'DISABLED!/bin/bash' ; 
            $disable['sambaAcctFlags'] = '[DU         ]' ; 
	    ldap_modify ($ldap, $value, $disable);
        }
        break ; 
    case "userDelete":
        $userToDelete = array () ; 
        $memberUid = '' ; 
        foreach ($_POST as $key => $value) 
            if (strpos($key, 'checked_') === 0 ) {
		$want = array ('memberUid') ; 
		$filter= '(&(objectClass=posixGroup))' ; 
                $result = ldap_search ($ldap, $value, $filter, $want) ; 
                $entries = ldap_get_entries ($ldap, $result) ; 
                if ($entries[count])
                    for ($group = 0 ; $group < $entries[count] ; $group++) {
                        $members = $entries[$group]['memberuid'] ; 
                        for ($member = 0 ; $member < $members[count] ; $member++) {
                            $memberUid .= '(uid=' . $members[$member] . ')' ; 
                        } 
                    }
                else {
		    $userToDelete[] = $value ; 
		}
	    }
	if (! empty ($memberUid)) {
	    $want = array () ; 
	    $filter = '(&(objectClass=posixAccount)(|' . $memberUid . '))' ; 
	    $result = ldap_search ($ldap, $base, $filter, $want) ; 
	    $entries = ldap_get_entries ($ldap, $result) ; 
	    for ($dn = 0 ; $dn < $entries[count] ; $dn++) 
		$userToDelete[] =$entries[$dn]['dn'] ; 
        }
	if (empty ($userToDelete)) {
	    printf (_("No users to delete")) ;
	    break ;
	}
        $smarty->assign ('userToDelete', $userToDelete) ; 
        $smarty->display ('admin_user_delete.tpl') ; 
        break ; 
    case "userDoDelete":
        $userToDelete = array () ; 
        foreach ($_POST as $key => $value) 
            if (strpos($key, 'checked_') === 0 ) {
		$userToDelete[] = $value ; 
	    }
	if (empty ($userToDelete)) {
	    printf (_("No users to delete")) ;
	    break ;
	}
        $want = array ('cn') ; 
        foreach ($userToDelete as $value ) {
            $filter = "member=" . $value ; 
	    $result = ldap_search ($ldap, $base, $filter, $want);
	    $entries = ldap_get_entries ($ldap, $result);
	    for ($i = 0 ; $i < $entries['count']; $i++) {
	        $remove = array ("member" => $value) ; 
	        ldap_mod_del ($ldap, $entries[$i]["dn"], $remove) ; 
	    }
        }
        foreach ($userToDelete as $value ) {
            $dn = ldap_explode_dn ($value, 1) ; 
            $filter = "memberUid=" . $dn[0] ; 
	    $result = ldap_search ($ldap, $groupbase, $filter, $want);
	    $entries = ldap_get_entries ($ldap, $result);
	    for ($i = 0 ; $i < $entries[count]; $i++) {
	        $remove = array ("memberUid" => $dn[0]) ; 
	        ldap_mod_del ($ldap, $entries[$i]["dn"], $remove) ; 
	    }
        }
        foreach ($userToDelete as $value ) {
            $dn = ldap_explode_dn ($value, 0) ; 
            $want = array ('gidNumber') ; 
            $filter = $dn[0] ; 
	    $result = ldap_search ($ldap, $base, $filter, $want);
	    $entries = ldap_get_entries ($ldap, $result);
            $want = array ('memberUid') ; 
	    $filter = "(&(objectClass=posixGroup)(gidNumber=" . 
	               $entries[0]['gidnumber'][0] . "))" ; 
	    $result = ldap_search ($ldap, $base, $filter, $want);
	    $entries = ldap_get_entries ($ldap, $result);
	    if ($entries[count]) {
		if ($entries[0]["memberuid"][count] == 0)
		    ldap_delete ($ldap, $entries[0]["dn"]) ; 
		ldap_delete ($ldap, $value) ; 
	    }
        }
        break ; 
    case "addGroup":
	addGroup ($ldap, readKey('cn'), readKey('description')); 
        break ; 
    case "addHost":
	addHost ($ldap, readKey('cn'), readKey('ipaddress'), readKey('domain')); 
        break ; 
    case "getUsername":
        $cn=readKey('cn'); 
        if ($cn == "") {
            $username= "" ;
        } else
            $username = get_username ($ldap, $cn) ;
        printf ('<input type=text name=username maxlength=8 value="%s">', $username) ;
        break ; 
    case "newPassSet":
	$filter="(&(objectClass=posixAccount)(uid=" . readKey('uid') . "))";
	$want = array ('uid', 'cn') ; 
	$result= ldap_search ($ldap, $base, $filter, $want);
	$entries = ldap_get_entries ($ldap, $result);
	$newpw = pwgen (); 
	$cryptpw = cryptgen ($newpw); 
	$sambahash = new smbHash () ;
	$info = array ();
	$info["userPassword"][] = $cryptpw ;
	$info["sambaLMPassword"][] = $sambahash->lmhash($newpw) ; 
	$info["sambaNTPassword"][] = $sambahash->nthash($newpw);
	$result = ldap_modify ($ldap,$entries[0]["dn"],$info) ;
	printf(_("Changed password for %s ( %s ) to %s ."),$entries[0]['uid'][0],$entries[0]['cn'][0], $newpw );
        showUser ($ldap, $authenticated, $entries[0]['uid'][0]); 
	break ;
    case "logout":
	setcookie ('Authenticated', 'false', time () + 1800) ;
	setcookie ('admindn', 'dummy', time() + 1800) ;
	setcookie ('xorstring', 'dummy', time() + 1800) ;
	unset ($_SESSION['key']) ; 
	$smarty->assign ('authenticated', 'false') ;
	$smarty-> display ('admin_login.tpl') ; 
	break ;
    case "newPassAsk":
        if ($authenticated) {
        printf (_("Are you sure you want to set a new password ?")) ;
?>
        <BR>
        <input type=button name=Yes value=Yes onClick="Action('newPassSet&uid=<?php echo readKey('uid') ; ?>', 'main');">
<?php
        break ; 
        }
    case "login":
        $adminUser=readKey('admindn') ;
        $filter = '(|(&(objectClass=posixAccount)(uid=' . $adminUser . '))(&(objectClass=simpleSecurityObject)(cn=' . $adminUser . ')))' ; 
        $want = array () ; 
        $result = ldap_search($ldap, $base, $filter, $want);
        $entries = ldap_get_entries ($ldap, $result); 
        $admindn = $entries[0]['dn'] ; 
        $adminpw=readKey('adminpw') ;
	$bind = @ldap_bind ($ldap, $admindn, $adminpw); 
	if ($bind) {
	    $key = crypt(sprintf (gettimeofday (true))) ;
	    $_SESSION['key'] = $key ; 
	    $xorstring= xorstring ($key, $adminpw); 
	    setcookie ('Authenticated', 'True', time () + 1800) ;
	    setcookie ('admindn', $admindn, time () + 1800) ;
	    setcookie ('xorstring', $xorstring, time () + 1800) ;
	    $smarty->assign('authenticated', 'true') ; 
	}
    case "loginForm":
        $smarty->display('admin_login.tpl') ; 
        break ;
    case "machineSearchForm":
        $smarty->display('admin_machine_search.tpl') ;
        break ;
    case "machineSearch":
        $searchFor=readKey('Name') ;
        if ($searchFor <> "") showResult ($ldap, 'Hosts', $searchFor, ''); 
        break ;
    case "showHost":
        showHost ($ldap, $authenticated, readKey('text')); 
        break ;
    default:
        echo "Function not implemented (yet). This is som debug info:" ;
        debug ($_POST);
        break ;
}
ldap_close ($ldap);

?>
